#!/usr/bin/perl

package main;
use strict;
require './ini.pl';
require './std.pl';

my %DAT = ();
my $EDITFLG = 0;
my %COOKIE;

##---------------
## main

&data_read;
&form_read;
&std::head_out;
&table_out;
&std::footer_out;
exit;

##---------------

## data_read
sub data_read {
	foreach ( @ini::CITY ) {
		$DAT{$_} = {};
	}
	open( FILE, "<$ini::DATAFILE" ) or &std::err(1);
	my $line;
	while ( <FILE> ) {
		( my $city, undef ) = split( /\t/, $_ );
		my $re = $DAT{$city};
		( undef, $re->{'date'}, $re->{'faction'}, $re->{'taxrate'}, $re->{'vendor'}, $re->{'comment'} )
			 = split( /\t/, $_ ) if $DAT{$city} ne undef;
	}
	close FILE;
}

## form_read
sub form_read {
	return unless ( $ENV{'REQUEST_METHOD'} eq 'GET' );
	foreach ( split(/[;&]/, $ENV{'QUERY_STRING'}) ) {
		if ( $_ =~ /^(?:c\=)(.+)$/ and $DAT{$1} ne undef ) {
			$DAT{$1}->{'edit'} = 1;
			$EDITFLG = 1;
		}
	}
}

## table_out
sub table_out {
	my ( $request_method, $action, $pass, $submit, $caution, $counter );
	if ( $EDITFLG ) {
		&read_cookie;
		$request_method = 'POST';
		$action = $ini::POSTCGIURL;
		$pass = qq!Username : <input type="text" name="username" size="12" value="$COOKIE{'name'}"> Password : <input type="password" name="pass" size="12" value="$COOKIE{'pass'}"> !;
		$submit = 'Submit';
		$caution = $ini::CAUTION;
	} else {
		$request_method = 'GET';
		$action = $ini::CGIURL;
		$submit = 'Edit';
		$counter = '<p class="counter">' . &counter . '</p>';
	}

	print  <<HTML;
<form action="$action" method="$request_method">
<table summary="City Information" border="1" cellspacing="0"><tbody>
	$ini::TABLEHEADER
HTML

	foreach ( @ini::CITY ) {
		my $re = $DAT{$_};
		my $faction = $re->{'faction'};
		my $checkbox;
		if ( $re->{'edit'} ) {
			$re->{'faction'} = &make_select( "$_^faction", \@ini::FACTION, $re->{'faction'} );
			$re->{'taxrate'} = &make_select( "$_^taxrate", \@ini::TAXRATE, $re->{'taxrate'} );
			$re->{'vendor'}  = &make_vendorlist( 1, $_ );
			$re->{'comment'} = qq!<input type="hidden" name="cities" value="$_"><input type="text" name="$_^comment" value="$re->{'comment'}" size="32">!;
		} else {
			$re->{'vendor'}  = &make_vendorlist( 0, $_ );
			$checkbox = qq!<input type="checkbox" value="$_" name="c">! unless $EDITFLG;
		}
		$re->{'comment'} =~ s/^(.*?)\x0D?\x0A?$/$1/;
		$re->{'comment'} = '&nbsp' if $re->{'comment'} eq "";
		$re->{'date'}    = &time_read( $re->{'date'} );
		print qq!\t<tr><th>$_</th><td>$checkbox$re->{'date'}</td><td class="$faction">$re->{'faction'}</td><td>$re->{'taxrate'}%</td><td>$re->{'vendor'}</td><td class="comment">$re->{'comment'}</td></tr>\n!;
	}

	print <<HTML;
</tbody></table>
$counter
<p>$pass<input class="button" type="submit" value="$submit"></p>
$caution
</form>
HTML

}

## make_select
sub make_select {
	my $name = shift;
	my $list = shift;
	my $selected = shift;
	my $str = qq!<select name="$name">!;
	foreach ( @$list ) {
		my $opt = ' selected' if $selected eq $_;
		$str .= qq!<option value="$_"$opt>$_</option>!;
	}
	$str .= '</select>';
}

## make_vendorlist
sub make_vendorlist {
	my $editmode = shift;
	my $city = shift;
	my @selected = split( /,/, $DAT{$city}->{'vendor'} );
	my $str = "";
	if ( $editmode ) {
		my $key;
		foreach $key ( keys %ini::VENDOR ) {
			my $opt;
			$opt = 'checked' if grep( /^$key$/, @selected );
			$str .= qq!<input type="checkbox" value="$key" name="$city^vendor" $opt><img src="$ini::VENDOR{$key}->[0]" alt="$ini::VENDOR{$key}->[1]">!;
		}
	} else {
		if ( @selected ) {
			foreach ( @selected ) {
				$str .= qq!<img src="$ini::VENDOR{$_}->[0]" alt="$ini::VENDOR{$_}->[1]">! if $ini::VENDOR{$_} ne undef;
			}
		} else {
			$str = '&nbsp;';
		}
	}
	$str;
}

## time_read
sub time_read {
	my $seed = shift;
	my( $sec, $min, $hour, $mday, $mon, $year, $wday ) = localtime( $seed );
	$year += 1900 if ($year < 1900);
	sprintf( qq!<span title="%4d %2d/%2d %2d:%02d">%d/%d</span>!, $year, $mon+1, $mday, $hour, $min, $mon+1, $mday );
}


## counter
sub counter {
	my $addr = $ENV{'REMOTE_ADDR'};
	open FILE, "+<$ini::COUNTLOG" or die;
	flock FILE, 2;
	my ( $count, $ip ) = split( /:/, <FILE> );
	seek( FILE, 0, 0 );
	if ( $ENV{'HTTP_REFERER'} !~ /^$ini::COUNTEXREF/ and $addr ne $ip ) {
		$count++;
		print FILE "$count:$addr";
	} else {
		seek( FILE, 0, 2 );
	}
	truncate( FILE, tell );
	close FILE;
	sprintf ( "%.8d", $count );
}

## read_cookie
sub read_cookie {
	my( $name, $value );
	foreach ( split(/;/,$ENV{HTTP_COOKIE}) ) {
		( $name, $value ) = split( /=/,$_ );
		$name =~ s/ //g;
		$value =~ s/\+/ /g;
		$value =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C",hex($1))/eg;
		$value =~ s/%(..)/pack('H2',$1)/eg;
		foreach ( split(/,/,$value) ) {
			( $name, $value ) = split(/:/,$_,2);
			$value =~ s/"/&quot;/g;
			$value =~ s/</&lt;/g;
			$value =~ s/>/&gt;/g;
			$COOKIE{$name} = $value;
		}
	}
}
