#!/usr/bin/perl

package main;
use strict;
require './ini.pl';
require './std.pl';

my %DAT;


##---------------
## main

&std::head_out;
&data_read;
&std::footer_out;
exit;

##---------------

## data_read
sub data_read {
	print  <<HTML;
<table summary="City Information Update Log" border="1" cellspacing="0"><tbody>
	<tr class="tablehead"><th>Username/IP</th><th>Date</th><th>Details</th></tr>
HTML
	open( FILE, "<$ini::LOGFILE" ) or &std::err(1);
	while ( <FILE> ) {
		( $DAT{'name'}, $DAT{'ip'}, $DAT{'city'}, $DAT{'date'}, $DAT{'faction'}, $DAT{'taxrate'}, $DAT{'vendor'}, $DAT{'comment'} ) = split( /\t/, $_ );
		$DAT{'date'} = &time_read( $DAT{'date'} );
		$DAT{'ip'}   = &mask_ip( $DAT{'ip'} ) if $ini::IPMASK;
		$DAT{'name'} = $DAT{'ip'} if $DAT{'name'} eq 'guest';
		print qq!<tr><td>$DAT{'name'}</td><td>$DAT{'date'}</td><td class="details">$DAT{'city'}/$DAT{'faction'}/$DAT{'taxrate'}%/$DAT{'comment'}</td><tr>!;
	}
	close FILE;
	print '</tbody></table>';
}

## mask_ip
sub mask_ip {
	my $host = shift;
	if ( $host =~ /\.\d+$/ ) {
		$host =~ s/\.\d+$/\.\*/;
	} else {
		$host =~ s/^.*?\./\*\./;
	}
	$host;
}

## time_read
sub time_read {
	my $seed = shift;
	my( $sec, $min, $hour, $mday, $mon, $year, $wday ) = localtime( $seed );
	$year += 1900 if ($year < 1900);
	sprintf( qq!%2d/%2d <span class="time">%2d:%02d</span>!, $mon+1, $mday, $hour, $min );
}

