#!/usr/bin/perl

package main;
use strict; 
require './ini.pl';
require './std.pl';

my %FORM;
my %USER;
my @DAT = ();


##---------------
## main

&read_form and &write_data;
&location_out;

##---------------

## write_data
sub write_data {
	&set_cookie;
	open( FILE, "+<$ini::DATAFILE" ) or &std::err(1);
	flock( FILE, 2 );
	@DAT = <FILE>;
	my ( $city, $flg, $str );
	foreach $city ( keys %FORM ) {
		$flg = 0;
		foreach ( 0 .. @DAT - 1 ) {
			( $str, undef ) = split( /\t/, $DAT[$_] );
			if ( $city eq $str ) {
				$DAT[$_] = $FORM{$city};
				$flg++;
			}
		}
		push ( @DAT, $FORM{$city} ) unless $flg;
	}
	seek( FILE, 0, 0 );
	print FILE @DAT;
	truncate( FILE, tell );
	close FILE;

	@DAT = ();
	open( FILE,"+<$ini::LOGFILE" ) or &std::err(1);
	flock( FILE, 2 );
	@DAT = <FILE>;
	foreach ( keys %FORM ) {
		unshift( @DAT, "$USER{'name'}\t$USER{'host'}\t$FORM{$_}" );
	}
	splice( @DAT, $ini::MAXLOG )  if @DAT > $ini::MAXLOG;
	seek( FILE, 0, 0 );
	print FILE @DAT;
	truncate( FILE, tell );
	close FILE;
}

## location_out
sub location_out {
	print "Location: $ini::CGIURL\n\n";
}

## _kill_tag
sub _kill_tag {
	my $value = shift;
	$value =~ s/&/&amp;/g;
	$value =~ s/"/&quot;/g;
	$value =~ s/</&lt;/g;
	$value =~ s/>/&gt;/g;
	$value =~ s/\x0D\x0A//g;
	$value =~ s/\x0D//g;
	$value =~ s/\x0A//g;
	$value =~ s/\t//g;
	return $value;
}

## read_form
sub read_form {
	my %tmp = ();
	$tmp{'date'} = time;
	&std::err(6) if ( $ENV{'CONTENT_LENGTH'} > $ini::MAXSIZE );
	my ( $buffer, $name, $value, $pair );
	my @pairs;
	read( STDIN, $buffer, $ENV{'CONTENT_LENGTH'} );
	return 0 unless $buffer;
	@pairs = split( /&/, $buffer );
	foreach $pair ( @pairs ) {
		$pair =~ tr/+/ /;
		( $name, $value ) = split( /=/, $pair );
		$value =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack("c", hex($1))/ge;
		$name  =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack("c", hex($1))/ge;
		$value = &_kill_tag( $value );
		$tmp{$name} = $tmp{$name}? "$tmp{$name}\t$value" : $value;
	}

	$USER{'name'} = $tmp{'username'};
	$USER{'pass'} = $tmp{'pass'};
	my ( $city, $flg );

	if ( $USER{'name'} eq undef and $USER{'pass'} eq undef ) {
		if ( $ini::GUEST ) {
		 	$USER{'name'} = 'guest';
		} else {
			&std::err(3);
		}
	} else {
		open( FILE, "<$ini::MEMFILE" ) or &std::err(1);
		while ( <FILE> ) {
			my ( $num, $user, $key ) = split( /\t/, $_ );
			$key =~ s/^(.*?)\x0D?\x0A?$/$1/;
			$USER{'key'} = &std::crypt_key( $USER{'pass'}, $USER{'name'} );
			if ( $USER{'name'} eq $user and $USER{'key'} eq $key ) {
				$flg = 1;
				last;
			}
		}
		close FILE;
		&std::err(11) unless $flg;
	}

	$flg = 0;
	my @cities = split( /\t/, $tmp{'cities'} );
	foreach $city ( @cities ) {
		my $key;
		&std::err(7) unless grep( /^$city$/, @ini::CITY );
		$FORM{$city} = qq!$city\t$tmp{'date'}\t!;

		$key = $city . '^faction';
		&std::err(8) unless grep( /^$tmp{$key}$/, @ini::FACTION );
		$FORM{$city} .= qq!$tmp{$key}\t!;

		$key = $city . '^taxrate';
		( $_ = $tmp{$key} ) =~ tr/+//;
		&std::err(9) unless grep( /^$_$/, @ini::TAXRATE );
		$FORM{$city} .= qq!$tmp{$key}\t!;

		my $vendor;
		$key = $city . '^vendor';
		foreach $vendor ( split( /\t/, $tmp{$key} ) ) {
			&std::err(10) unless grep( /^$vendor$/, keys %ini::VENDOR );
		}
		$tmp{$key} =~ tr/\t/,/;
		$FORM{$city} .= qq!$tmp{$key}\t!;

		$key = $city . '^comment';
		&std::err(5) if length( $tmp{$key} ) > $ini::MAXCHAR;
		$FORM{$city} .= qq!$tmp{$key}\n!;
		$flg++;
	}
	$USER{'host'} = &_host_read;
	return $flg;
}

## _host_read
sub _host_read {
	my $user = $ENV{'REMOTE_ADDR'};
	my $host = $ENV{'REMOTE_HOST'};
	if ( !&_chk_local ) {
		if ( $host eq '' or $host eq $user ) {
			$host = gethostbyaddr( pack("C4", split(/\./, $user)), 2 );
		}
	}
	$_ = ( $host eq '' )? $user : $host;
	$_ = "" if length > 100;
	&_kill_tag( $_ );
}
sub _chk_local {
	return ($ENV{'REMOTE_ADDR'} eq '127.0.0.1')? 1 : 0;
}

## set_cookie
sub set_cookie {
	my( $sec, $min, $hour, $mday, $mon, $year, $wday ) = gmtime( time + 60*24*60*60 );
	my @mons = qw( Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec );
	my @key  = qw( name pass );
	my %encoded;
	my $date_g = sprintf( "%s, %02d\-%s\-%04d %02d:%02d:%02d GMT", $ini::WDAYS[$wday], $mday, $mons[$mon], $year+1900, $hour, $min, $sec );
	foreach ( @key ) {
		( $encoded{$_} = $USER{$_} ) =~ s/([^\w\=\& ])/'%' . unpack("H2", $1)/eg;
	}
	my $ck = "name\:$encoded{'name'}\,pass\:$encoded{'pass'}";
	print "Set-Cookie: CINFO=$ck; expires=$date_g;\n";
}

